import ResultList;

public class Queen implements QueenIfc
{
	int iTotalNumberOfQueens = 0;
	int row, column;
	QueenIfc neighbour;
	
	public Queen( int aColumn, QueenIfc aQueen, int iNewTotalNumberOfQueens )
	{
		row = 0;
		column = aColumn;
		neighbour = aQueen;
		iTotalNumberOfQueens = iNewTotalNumberOfQueens;
	}
	
	public boolean canAttack( int testRow, int testColumn )
	{
		int columnDifference = testColumn - column;
		
		if ( (row == testRow) ||
				((row + columnDifference) == testRow) ||
				((row - columnDifference) == testRow) )
				return true;
		return neighbour.canAttack( testRow, testColumn );
	}
	
	public boolean advance()
	{
		if (row == iTotalNumberOfQueens)
		{
			if (!neighbour.hasNextSolution())
				return false;
			row = 0;
		}
		
		row += 1;
		return true;
	}
	
	public boolean moveToNextNonAttackedRow()
	{
		while (neighbour.canAttack( row, column ))
		{
			if (!advance())
				return false;
		}
		
		return true;
	}
	
	public boolean hasFirstSolution()
	{
		if (!neighbour.hasFirstSolution())
			return false;
		row = 1;
		
		return moveToNextNonAttackedRow();
	}
	
	public boolean hasNextSolution()
	{
		return ( advance() && moveToNextNonAttackedRow() );
	}
	
	public ResultList gatherResult()
	{
		return neighbour.gatherResult().addLast(row);
	}
}